<cfcomponent
	displayname="BASE per form"
	hint="fa girare il meccanismo che costruisce e muove le form"
>

<!---- 
NB: questo e' il meccanismo di base che fa girare la form. 
In quelle che lo estendono devono OBBLIGATORIAMENTE esserci, anche vuote: 
--->

<cffunction name="refill" access="private" returntype="void">
</cffunction>

<cffunction name="businessLogicCK" access="private" returntype="void">
</cffunction>

<cffunction name="nonStandardCK" access="private" returntype="void">
</cffunction>

<cffunction name="doSomething" access="private" returntype="void">
</cffunction>

<cffunction name="run" access="public" returntype="void" output="yes">
	<cfargument name="myID" type="string" required="yes">
	<cfargument name="fileXML" type="string" required="yes">
	<cfargument name="myLang" type="string" required="yes">
	<cfargument name="myFL" type="string" required="yes">
	<cfargument name="debug" type="boolean" required="no" default="false">

	<cfparam name="FORM.Run" default="1st">

	<cfif debugmode><cfdump var="#FORM#"></cfif>
	
	<cfscript>
		// pulisce l'oggetto degli errori (mixCFC.mixform.utils.error.holder)
		SESSION.mixForms.dataErrObj.clearError();

		// se e' il primo passaggio, costruisce l'oggetto "form" e lo mette in SESSION
		if (FORM.Run EQ "1st") {
			//rigenera l'oggetto XML
			load( fileXML );
			if (( MyLanguage NEQ "" ) AND ( len(MyLanguage) IS 2 )) setLanguage( MyLanguage );
		}

		if (FORM.Run EQ "1st") {
			// inizializza le variabili della FORM (definito in mixCFC.form.handler)
			createDefaults();
			refill();
			FORM.Run = "get";
		}
		else {
			// controlli standard
			runCK();
			// controlli NON standard (se ce ne sono)
			nonStandardCK();
			businessLogicCK();
			// se tutto OK, scrive
			if ( THIS.eObj.errorFree() ) FORM.Run = "set";
		}
		
		// manda avanti la form
		switch ( FORM.Run ) {
			case "1st": createForm(); break;
			case "get": createForm(); break;
			case "set": doSomething(); break;
		} // end switch
	</cfscript>

</cffunction>

</cfcomponent>