<cfcomponent 
	displayname="Blocks" 
	hint="container di oggetti 'block' e esecutore di operazioni di gruppo"
> 

<cfscript>init();</cfscript>

<!---
	FUNZIONE
--->
<cffunction name="setup" access="public" returntype="void">
	<cfargument name="myXML" type="xml" required="yes">
	<cfargument name="myParams" type="any" required="yes">

	<cfscript>
		myArray=ARGUMENTS.myXML.XmlChildren;
		mylen=arrayLen(myArray);
		for(k=1; k LTE myLen; k++) {
			myName = myArray[k].XmlName; 
			myType = myArray[k].type.XmlText; 

			switch( myType ) {

				case "standard": tmpObj = createObject("component", "mixCFC.mixform.elems.block.standard"); break;

				default: 
					SESSION.mixForms.sysErrObj.write("BLOCK TYPE [" & myType & "] in unknown: used [standard]", warning);	
					tmpObj = createObject("component", "mixCFC.mixform.elems.block.base"); 
				break;

			}//END switch

			tmpObj.setup( myArray[k], ARGUMENTS.myParams );
			// con questo controllo solo le righe che devono effettivamente essere stampate vengono salvate
			// si risparmierebbe memoria in SESSION 
			// al momemnto non lo facciamo
			// if ( tmpObj.isOK() ) THIS[ myName ] = tmpObj;
			THIS[ myName ] = tmpObj;
		}
	</cfscript>

</cffunction>

<!---
	COSTRUTTORE
--->
<cffunction name="init" access="private" returntype="void">
</cffunction>

</cfcomponent>