<cfcomponent 
	extends="base" 
	hint="Crea una riga CF RICH TEXT"
>

<!--- 
	GETTER & SETTER: toolbar
--->
<cffunction name="getToolbar" access="public" returntype="string">
	<cfreturn THIS.toolbar>
</cffunction>


<!--- 
	UTILITY: se c'e' estrae TOOLBAR da XML: il nome e' CASE SENSITIVE e si occupa di estrarlo corretto
--->
<cffunction name="extractToolbar" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet="Basic";
		if ( isDefined("ARGUMENTS.myXML.write.toolbar") ) {
			tmp=ARGUMENTS.myXML.write.toolbar.XmlText;
			switch ( ucase(tmp) ) {
				case "BASIC": tmp="Basic"; break;
				case "DEFAULT": tmp="Default"; break;
				default: 
					SESSION.mixForms.sysErrObj.write("string to be used as TOOLBAR in CFRICHTEXT is incorret: passed value [" & tmp & "]", "warning");
					break;
			}//END switch
			myRet = tmp;
		}
		return(MyRet);
	</cfscript>
	
</cffunction>


<!--- 
	UTILS: chiama la build e fa le "estrazioni" di base
--->
<cffunction name="setup" access="public" returntype="void">
	<cfargument name="myLineXML" type="xml" required="yes">
	<cfargument name="myParams" type="any" required="yes">

	<cfscript>
		setupBase( ARGUMENTS.myLineXML, ARGUMENTS.myParams );
		// se si devono fare altre estrazioni, questo e' il momento
		THIS.toolbar=extractToolbar(myLineXML);
	</cfscript>

</cffunction>

</cfcomponent>