<cfcomponent>

<!--- crea la tabella necessaria per creare --->
<cffunction name="buildSmartTable" access="public" returntype="query">
	<cfargument name="MyXML" type="xml" required="yes">
	<cfargument name="MyLang" type="string" required="yes">

	<cfquery datasource="#MyXML.MyDatasource.XmlText#" name="THIS.MyQ">
		SELECT
			d.val AS MyVal, d.#MyXML.textColumn.XmlText# AS text,
			f.key, f.flag_list, f.line_type
		FROM #MyXML.formatTable.XmlText# f, #MyXML.dataTable.XmlText# d
		WHERE
			f.ok=1
			AND d.ok=1
			AND f.val=d.val
			AND line_type!='hidden'
			AND ( lang='#MyLang#' || lang='xx' )
			AND CURDATE() >= bd
			AND CURDATE() <= ed
		ORDER BY ord ASC, text ASC
	</cfquery>
	<cfreturn THIS.MyQ>

</cffunction>


<cffunction name="getSimpleBlobTable" access="public" returntype="query">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfquery datasource="#MyXML.MyDatasource.XmlText#" name="THIS.MyQ">
		SELECT 
			b.#MyXML.valueColumn.XmlText# AS myValue,
			b.#MyXML.blobColumn.XmlText# AS myBlob 
		FROM #MyXML.dataTable.XmlText# b 
		WHERE	b.ok=1
		ORDER BY ord ASC
	</cfquery>
	<cfreturn THIS.MyQ>

</cffunction>


</cfcomponent>